/*
Date: 2014/7/10
Author: Akinori Tsuji
*/
#include <Servo.h>

const int servoL_Pin  = 9; // uses timer1
const int servoR_Pin  = 5; // uses timer1
Servo servoL; // left servo
Servo servoR; // right servo
const int swPin = 8;

int centerL=1495, centerR=1472, pwL=680, pwR=720;

void setup() {
  Serial.begin(9600);
  servoL.attach(servoL_Pin, centerL-pwL, centerL+pwR);
  servoR.attach(servoR_Pin, centerR-pwL, centerR+pwR);
  motor(0,0); // stop
  pinMode(swPin, INPUT_PULLUP);
  while(digitalRead(swPin)); // wait until push the D8 switch
}

#define TH   750 // threshold value for photo refrector
int std_speed = 20;
int val[3] = {0, 0, 0}; // L, C, R
int pos[3] = {-std_speed, 0, std_speed}; // L, C, R
int out = 0;
float sum = 0;
float e0 = 0;

void loop(){
  int data_count;

  val[0] = analogRead(A0);
  val[1] = analogRead(A1);
  val[2] = analogRead(A2);

  data_count = 0;
  sum = 0;
  for (int i = 0; i < 3; i++) {
    if (val[i] > TH) {
      sum += pos[i];
      data_count++;
    }
  }

  if (data_count == 0) {
    e0 = 0;
  } else {
    e0 = sum / data_count;
  }
  
  Serial.println(e0);
  out = (int)e0;

  motor(std_speed + out, std_speed - out);
}

// l, r: 0-90
void motor(int l, int r) {
  servoL.write(90-l);
  servoR.write(90+r);
}

